# [ODA Framework](https://odajs.org/)
[![Welcome](https://img.shields.io/badge/ODA-welcome-brightgreen.svg)](https://odajs.org/#learn/guide/introduction/introduction.md)
 [![npm version](https://img.shields.io/npm/v/oda-framework.svg?style=flat)](https://www.npmjs.com/oda-framework) [![NPM downloads](https://img.shields.io/npm/dm/oda-framework.svg?sanitize=true)](https://npmcharts.com/compare/oda-framework?minimal=true") [![GitHub license](https://img.shields.io/badge/license-MIT-blue.svg)](https://github.com/odajs/oda/blob/main/LICENSE)

It's a progressive ES framework based on the technology of Web Components and designed especially for rapid development of custom UI/UX for web applications.

* **Features** The ODA Framework allows its users to create  interactive user interfaces of any complexity rapidly and easily. Web application code becomes as simple and straightforward as it is even possible for debugging and further distribution. Effective updating and rendering of an interface are carried out automatically whenever there is any change in the data itself or in the state of web components.
* **Technologies** It is used a component-oriented approach based on all 4 basic elements of the Web Components technology: Custom Elements, Shadow DOM, HTML Templates, and Modules. It implements all the requirements of PWA and PWC technologies.
* **Advantages** Simplicity of coding and learning, code minimization with its functionality maximization, the substantial increase of the development speed and extensibility due to the re-use of ready-made web components, both self- and third-party-developed. High rendering efficiency for any changes occurring within an interface. Capability to develop cross-platform mobile applications.

[Learn more about ODA Framework](https://odajs.org/#learn/guide/introduction/introduction.md).

## Installation

You can install ODA Framework as:

* a `<script>` tag from a [CDN](https://cdn.jsdelivr.net/gh/odajs/odajs/oda.js).
* a `<script>` tag from a [UNPKG](https://unpkg.com/browse/oda-framework@latest/oda.js).
* a `oda-framework` package on [npm](https://www.npmjs.com/package/oda-framework).
* a `oda-framework` package on [yard](https://yarnpkg.com/package/oda-framework).
* download [zip](https://github.com/odajs/oda/archive/refs/heads/main.zip) archive.

More ditails you can find in the [install notes](https://odajs.org/#learn/guide/install.md).

## Fast taste

Use online playgrounds to get a taste of ODA Framework.


* Our website [ODAjs](https://odajs.org/#learn/guide/hello-world.md).
* [CodePen](https://codepen.io/org-odajs/pen/QWMPVdZ): Online Code Editor and Front End Web Developer.

## Browser Compatibility

ODA Framework supports all browsers that are [ES5-compliant](http://kangax.github.io/compat-table/es5/) (IE8 and below are not supported).

## Documentation

You can find the ODA Framework documentation [on the website](https://odajs.org/#learn/guide).

Check out the [Getting Started](https://odajs.org/#learn/guide/hello-world.md) page for a quick overview.

The documentation is divided into several sections:

* [Tutorial](https://odajs.org/#learn/guide/structure)
* [Main Concepts](https://odajs.org/#learn/guide/introduction)
* [Components](https://odajs.org/#components)
* [API Reference](https://odajs.org/#learn/guide/api)
* [Where to Get Support](https://csc.odant.org/?page_id=20)
* [Our youtube channel](https://www.youtube.com/channel/UC37BC2N95knlYcDRK4cQoug)

You can improve it by sending pull requests to [this repository](https://github.com/odajs/oda/pulls).

## Questions

For questions and support please use [the official forum](http://forum.odajs.org) or [community chat](https://chat.odajs.org/). The issue list of this repo is **exclusively** for bug reports and feature requests.

## Issues

opening an issue.

Please make sure to read the [Issue Reporting Checklist](https://github.com/odajs/oda-framework/blob/dev/.github/CONTRIBUTING.md#issue-reporting-guidelines) before opening an issue. Issues not conforming to the guidelines may be closed immediately.

## Good First Issues

To help you get your feet wet and get you familiar with our contribution process, we have a list of [good first issues](https://github.com/odajs/oda-framework/labels/good%20first%20issue) that contain bugs which have a relatively limited scope. This is a great place to get started.

## Changelog

Detailed changes for each release are documented in the [release notes](https://github.com/odajs/oda/releases).

## Contribution

Please make sure to read the [Contributing Guide](https://github.com/odajs/oda/blob/dev/.github/CONTRIBUTING.md) before making a pull request. If you have a ODA-related project/component/tool, add it with a pull request to [this curated list](https://github.com/odajs/awesome-vue)!

Thank you to all the people who already contributed to ODA Framework!

## License

ODA Framework is [MIT licensed](./LICENSE).
