Компонент **«oda-palette»** генерирует палитру цветов, с помощью которой пользователь выбирает требуемый цвет или формирует правило линейной градиентной заливки.

Выбранный цвет или созданное правило возвращается в параметре **value** в виде строки. Строка с цветом содержит вызов функции **rgb()** с параметрами, соответствующими выбранному цвету. Строка с правилом заливки содержит вызов функции **linear-gradient()** с параметрами, соответствующими цветам, используемым для заливки. Можно задать до 6 цветов. Направление заливки в функции не указывается, т.е. заливка всегда формируется сверху вниз.

Для использования компонента необходимо подключить JS-модуль **palette.js** и добавить в HTML-код пользовательский тэг **oda-palette**.

```javascript _run_line_edit_loadoda_[my-component.js]_h=260_
import '/components/colors/palette/palette.js';
ODA({
    is: 'my-component',
    template: `
        <div>Щелкни по цвету:</div>
        <oda-palette ::value="myValue" gradient-mode></oda-palette>
        <div>Выбран цвет: {{myValue}}</div>
    `,
    props: {
        myValue: ''
    }
});
```

