﻿Свойство **gradientMode** включает в палитре цветов режим выбора градиента.

Если это свойство установить в значение **true**, то в палитре будет отображена дополнительная область, с помощью которой можно задать необходимый градиент цвета.

```javascript _run_line_edit_loadoda_[my-component.js]_h=260_
import '/components/colors/palette/palette.js';
ODA({
    is: 'my-component',
    template: `
        <label>Включить режим градиента: <input type="checkbox" ::value="gradientMode"></label>
        <oda-palette :gradient-mode :value></oda-palette>
        <div>Заданный градиент: {{value}}</div>
    `,
    props: {
        colors: 10,
        gradientMode: false,
        value: '',
    }
});
```

Первый цвет градиента изначально отсутствует. При его выборе изменится цвет маркера, который предназначен именно для него в области градиента. Для задания следующего цвета необходимо добавить новый маркер, щелкнув в области градиента левой кнопкой мыши. Цвет нового маркера задается также, как и цвет предыдущего. Аналогично задаются остальные цвета градиента, но их общее количество не может превышать значения 4.

Если какой-то цвет нужно исключить из градиента, то для этого необходимо первоначально выделить его маркер, а затем удалить его с помощью кнопки с изображением крестика, расположенной в верхнем правом углу области градиента.

Аналогично с помощью выделения маркера осуществляется редактирование ранее заданного цвета градиента.

Значение выбранного градиента возвращается компонентом в свойстве **value** в виде строкового значения CSS-функции **linear-gradient** с параметрами, который задал пользователь.

Если в градиенте был задан только один цвет, то компонент вернет не градиент, а значение выбранного цвета в виде CSS-функции **rgb**.
