Свойство **focusedItem** содержит текущий выделенный элемент списка.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=140_
import '/components/grids/list/list.js';
ODA({
    is: 'my-component',
    template: `
        <label>Выделенный элемент: <input ::value="focusedItem"></label>
        <oda-list :items ::focused-item></oda-list>
    `,
    props: {
        items: ["Элемент 1", "Элемент 2", "Элемент 3", "Элемент 4", "Элемент 5"],
        focusedItem: 'Щелкни по элементу'
    }
});
```

При щелчке левой или правой кнопки мыши по соответствующему элементу его значение будет записано в свойство **focusedItem**.

Это свойство можно использовать как для чтения, так и для записи. Например, если записать в него значение элемента из списка с помощью компонента **input**, то соответствующий элемент будет выделен в списке автоматически.

При любом изменении свойства **focusedItem** происходит событие **focused-item-changed**. Его можно обработать так, как показано в примере **«Событие focused-item-changed»** на вкладке **«Примеры»**.
