Свойство **autofocus** позволяет устанавливать фокус на контейнер с элементами списка во время создания компонента.

Если это свойство установлено в значение **true**, то при создании компонента его контейнер получит фокус, т.е. вокруг него появится рамка с дополнительным выделением.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=180_
import '/components/grids/listbox/listbox.js';
ODA({
    is: 'my-component',
    template: `
        <label>Автофокус <input type="checkbox" ::value></label>
        <oda-list-box :items autofocus></oda-list-box>
    `,
    props: {
        items: [
            {label: "Элемент 1", icon: 'icons:favorite'},
            {label: "Элемент 2", icon: 'icons:face'},
            {label: "Элемент 3", icon: 'icons:star'}
        ],
        value: true
    }
});
```

Контейнер списка в этом примере получит фокус только при создании компонента. Изменение значения свойства **autofocus** после этого никак не повлияет на текущий фокусный элемент. Его уже задает сам пользователь щелчком мыши.

Изначально свойство **autofocus** установлено в значение **false**, т.е. контейнер с элементами по умолчанию не будет находится в фокусе.
