Свойство **filter** используется для фильтрации списка элементов.

В нем указывается список значений, который определяет какие элементы из массива **items** попадут в контейнер, а какие нет.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=140_
import '/components/grids/listbox/listbox.js';
ODA({
    is: 'my-component',
    template: `
        <label>Значение для фильтрации <input ::value="filter"></label>
        <oda-list-box :items :filter></oda-list-box>
    `,
    props: {
        items: [
            {label: "Элемент 1", icon: 'icons:favorite'},
            {label: "Элемент 2", icon: 'icons:face'},
            {label: "Элемент 3", icon: 'icons:star'}
        ],
        filter: "1 2"
    }
});
```

Список значение разделяется пробелами, как показано в этом примере. Если в форме ввода указать только числа 1 и 2, то третий элемент в контейнер не попадет, так как при проверке его надписи, указанной в свойстве **label**, значение 1 или 2 найдено не будет.

Изначально свойство **filter** задано пустой строкой. Поэтому в контейнер по умолчанию помещаются все элементы списка **items**.
