Свойство **iconSize** предназначено для указания размера иконки, отображаемой с левой стороны от надписи элемента списка.

По умолчанию размер иконки установлен в значение **24** пикселя. Однако сама иконка появляется только тогда, когда элемент списка является объектом, у которого в свойстве **icon** указана ссылка на соответствующую иконку.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=160_
import '/components/grids/listbox/listbox.js';
ODA({
    is: 'my-component',
    template: `
        <label> Размер иконки: <input type="number" min="0" max="100" ::value="iconSize">px</label>
        <oda-list-box :items :icon-size></oda-list-box>
    `,
    props: {
        items: [
            {label: 'Элемент 1', icon: 'icons:favorite'},
            {label: 'Элемент 2', icon: 'icons:face'},
            {label: 'Элемент 3', icon: 'icons:star'},
        ],
        iconSize: 24
    }
});
```

Как видно из примера, изменение свойства **iconSize** автоматически приводит и к изменению размера иконки и к изменению высоты строки, используемой для отображения элемента. При этом размер иконки и высота строки изменяется одновременно у всех элементов списка.
