Свойство **items** определяет список элементов, которые могут отображаться данным компонентом.

По своей структуре данное свойство является массивом, элементы могут отображаться внутри отдельного контейнера.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=120_
import '/components/grids/listbox/listbox.js';
ODA({
    is: 'my-component',
    template: `
        <oda-list-box :items></oda-list-box>
    `,
    props: {
        items: ["Элемент 1", "Элемент 2", "Элемент 3"]
    }
});
```

В данном примере использовался массив с примитивным типом элементов **string**. Однако
в качестве элементов массива можно использовать и более сложные структуры данных, такие как объекты или пользовательские компоненты. Подробнее об этом можно узнать из описания свойств **iconSize** и **defaultTemplate** данного компонента, а также из демонстрационного примера «**Пользовательский список элементов**».
