Свойство **allowCheck** позволяет отображать дополнительные кнопки множественного выбора **checkBox** у узлов в столбцах таблицы, которые отображают данные в виде дерева.

Если это свойство уставлено в значение **true**, то кнопки множественного выбора будут отображаться у всех узлов деревьев, заданных в столбцах таблицы.

Для того чтобы столбец таблицы отображал данные в виде дерева, при его объявлении в массиве **columns** необходимо задать свойство **treeNode** со значением **true**.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=160_
import '/components/grids/table/table.js';
ODA({
    is: 'my-component',
    template: `
        <label>Показать кнопки выбора <input type="checkbox" ::value="allowCheck" ></label> <br>
        <div>Выбранный узел: {{checkNode}}</div>
        <oda-table :data-set :allow-check show-header></oda-table>
    `,
    props: {
        columns: [
            {name: 'col1', label: 'Столбец 1'},
            {name: 'col2', label: 'Столбец 2', treeMode: true}
        ],
        dataSet: [
            {col1: "1 строка", col2:"1 узел",
                items:[
                    {col2: "2.1 узел"},
                    {col2: "2.2 узел",
                    items:[
                        {col2:"2.2.1 узел"},
                        {col2:"2.2.2 узел"},
                        {col2:"2.2.3 узел"},
                    ]},
                    {col2:"2.3 узел"}
                ]
            },
            {col1: "2 строка"},
        ],
        allowCheck: false,
        checkNode: ''
    },
    listeners: {
        checked(e) {
            this.checkNode = e.detail.value.name;
        }
    }
});
```

При щелчке по кнопке меняется ее состояние, которое сохраняется в свойстве  **checked** соответствующего узла. Кроме этого, генерируется событие с именем **checked**, которому в качестве параметра **value** передается тот узел, который был выбран в данный момент.

По умолчанию свойство **allowCheck** установлено в значение **false**. Поэтому дополнительные кнопки множественного выбора изначально не отображаются.
