Свойство **allowSort** позволяет сортировать строки таблицы по возрастанию или по убыванию.

Если это свойство уставлено в значение **true**, то в заголовке столбца появляется дополнительный элемент в виде изображения стрелки, при нажатии на которую строки сортируются по возрастанию или по убыванию их значений.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=160_
import '/components/grids/table/table.js';
ODA({
    is: 'my-component',
    template: `
        <label>Разрешить сортировку <input type="checkbox" ::value="allowSort" ></label>
        <oda-table ref="tree" :allow-sort :data-set :columns show-header></oda-table>
    `,
    props: {
        columns: [
            {name: 'col1', label: 'Столбец 1'},
            {name: 'col2', label: 'Столбец 2'}
        ],
        dataSet: [
            {col1: "1 Строка", col2: "3"},
            {col1: "2 Строка", col2: "2"},
            {col1: "1 Строка", col2: "1"}
        ],
        allowSort: false
    }
});
```

Для сортировки узлов обязательно необходимо отобразить заголовок столбца, задав значение **true** у свойства **showHeader**.

При нажатии на иконку с изображением стрелки сортировка строк меняться последовательно с возрастания на убывание, а при каждом третьем нажатии будет возвращаться исходный порядок узлов, указанный в наборе данных **dataSet**.

По умолчанию свойство **allowSort** установлено в значение **false**. Поэтому строки изначально сортироваться не будут.
