Свойство **cols** возвращает расширенный массив столбцов **colsHead**.

В отличие от массива **colsHead** в данный массив вместо корневого родительского столбца добавляются все его развернутые столбцы со вложенными подзаголовками.

Для задания вложенного подзаголовка в объекте столбца, хранящегося в массиве **columns**, необходимо добавить свойство **items** в виде массива объектов, которые будут определять свойства вложенных столбцов.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=260_
import '/components/grids/table/table.js';
ODA({
    is: 'my-component',
    template: `
        <div>Количество столбцов в colsHead: {{$refs.table.colsHead.length}}
        </div>
        <div>Количество столбцов в cols: {{$refs.table.cols.length}}
        </div>
        <div>Столбец colsHead: {{$refs.table.colsHead[0].name}}</div>
        <div>Столбец cols: {{$refs.table.cols[0].name}}</div>
        <oda-table ref="table" :data-set show-header :columns auto-width></oda-table>
    `,
    props: {
        columns: [
            {name: 'col1', label: 'Расширенный столбец', $expanded: true,
                items: [
                    {name: 'col11', label: 'Вложенный столбец 1'},
                    {name: 'col12', label: 'Вложенный столбец 2'}
                ]
            }
        ],
        dataSet: [
            {col11: "1 Строка", col12: "1"},
            {col11: "2 Строка", col12: "2"},
            {col11: "3 Строка", col12: "3"}
        ]
    }
});
```

Если в таблице нет вложенных столбцов или расширенные заголовки не развернуты, то массив **cols** будет совпадать по содержимому с массивом **colsHead**.

Для того чтобы вложенные заголовки были развернуты по умолчанию, в родительском столбце необходимо задать свойство **$expanded** со значением **true**.

Кроме этого для каждого вложенного столбца первого уровня в массив **cols** добавляется свойство **$parent**, которое ссылается на родительский столбец из массива **colsHead**.
