Свойство **dataSet** задает исходный набор данных, на основе которого формируются строки таблицы.

По своей структуре это свойство является массивом. Каждый элемент этого массива задается в виде объекта, на основе свойств которого формируется соответствующая строка таблицы.

Если свойство этого объекта совпадает с названием столбца таблицы, то оно определяет надпись, отображаемую в соответствующей ячейке данной строки.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=160_
import '/components/grids/table/table.js';
ODA({
    is: 'my-component',
    template: `
        <oda-table :data-set :columns show-header col-lines></oda-table>
    `,
    props: {
        columns: [
            {name: 'col1', label: 'Столбец 1'},
            {name: 'col2', label: 'Столбец 2'}
        ],
        dataSet: [
            {col1: "1 Строка", col2: "1"},
            {col1: "2 Строка", col2: "2"},
            {col1: "2 Строка", col2: "3"}
        ]
    }
});
```

У объектов строк таблицы могут быть заданы и другие свойства:

1. **drag** — определяет, можно ли перетаскивать строку левой кнопкой мыши.
1. **drop** — определяет, можно ли вставлять строку при перетаскивании.
1. **checked** — определяет, выбран или нет узел, при отображении данных в виде дерева с помощью кнопок множественного выбора, если свойство **allowCheck** установлено в значение **true**.
1. **template** — определяет имя компонента, который будет использоваться для отображения именно этого узла дерева. По умолчанию все узлы дерева отображаются с помощью компонента **oda-table-cell**.
1. **icon** — определяет иконку, которая будет отображаться у узла дерева при использовании пользовательского компонента. В компоненте **oda-table-cell** по умолчанию иконка не предусмотрена. Ее нужно задавать в пользовательском компоненте, как показана в описании свойства **defaultTemplate**.
