Свойство **filters** содержит список столбцов, у которых заданы условия выбора строк таблицы.

Если пользователь в строке ввода укажет любой значение, то оно будет записано в свойство **$filter** текущего столбца, при этом ссылка на этот столбец будет добавлена в массив **filters** для более удобного и быстрого доступа ко всем заданным условиям выбора строк.

В результате этого в таблице будут отображаться только те строки, значения ячеек которых удовлетворяют всем условиям выбора, заданным в соответствующих столбцах.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=200_
import '/components/grids/table/table.js';
ODA({
    is: 'my-component',
    template: `
        <label>Показать фильтр <input type="checkbox" ::value="showFilter" checked></label>
        <div>Заданный фильтр: {{$refs.table.filters[0].$filter}} </div>
        <oda-table ref="table" :show-filter :data-set :columns show-header col-lines auto-width></oda-table>
    `,
    props: {
        columns: [
            {name: 'col1', label: 'Столбец 1'},
            {name: 'col2', label: 'Столбец 2'}
        ],
        dataSet: [
            {col1: "1 Строка", col2: "3"},
            {col1: "2 Строка", col2: "2"},
            {col1: "3 Строка", col2: "1"}
        ],
        showFilter: true
    }
});
```

Для возможности ввода фильтра необходимо первоначально отобразить строку заголовка столбца с помощью свойства **showHeader** и включить режим  отображения строк фильтрации, указав в свойстве **showFilter** значение **true**.

По умолчанию массив **filters** будет пустым, так как изначально условия фильтрации строк таблицы не заданы.

Если очистить фильтр у столбца, то свойство **$filter** из объекта столбца будет автоматически удалено, а ссылка на сам столбец будет удалена из массива **filters**.
