Свойство **focusedRow** предназначено для хранения указателя на текущий строку таблицы, которая находится в фокусе на данный момент.

Для того чтобы строка таблицы могла получать фокус, необходимо первоначально установить свойство **allowFocus** в значение **true**.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=200_
import '/components/grids/table/table.js';
ODA({
    is: 'my-component',
    template: `
        <label>Разрешение фокуса<input type="checkbox" ::value="allowFocus" checked></label> <br>
        <label>Строка в фокусе: <input ::value="focusedRow.col1"></label>
        <oda-table :data-set :columns ::focused-row :allow-focus show-header col-lines row-lines auto-width></oda-table>
    `,
    props: {
        columns: [
            {name: 'col1', label: 'Столбец 1'},
            {name: 'col2', label: 'Столбец 2'}
        ],
        dataSet: [
            {col1: "1 Строка", col2: "1"},
            {col1: "2 Строка", col2: "2"},
            {col1: "3 Строка", col2: "2"}
        ],
        allowFocus: true,
        focusedRow: {name: 'Щелкните по элементу'}
    }
});
```

При щелчке левой или правой кнопки мыши по ячейки любой строки ссылка на объект этой строки будет записана в свойство **focusedRow**.

Используя эту ссылку, можно узнать не только какая строка находится сейчас в фокусе, но и изменить значения ее элементов.

Это свойство можно использовать как для чтения, так и для записи. Например, если записать в него значение элемента из массива **items**, то соответствующий узел в структуре дерева получит фокус автоматически, как показано в примере **«Изменение фокуса»** на вкладке **«Примеры»**.

При любом изменении свойства **focusedRow** происходит событие **focused-row-changed**. Его можно обработать так, как показано в примере **«Событие focused-row-changed»** на вкладке **«Примеры»**.
