Свойство **groups** содержит список столбцов, по которым осуществляется группировка строк таблицы на данный момент.

Ссылка на любой столбец, который был помещен на группировочную панель, автоматически добавляет в массив **groups**, используя который можно получить доступ к всем группировочным столбцам таблицы.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=220_
import '/components/grids/table/table.js';
ODA({
    is: 'my-component',
    template: `
        <oda-table ref="table" :data-set :columns show-header show-grouping-panel :data-set col-lines auto-width></oda-table>
        <div>Группировочные строки</div>
        <div ~for="$refs.table.groups[0].map.values().next().value"> {{item.value}} </div>
    `,
    props: {
        columns: [
            {name: 'col1', label: 'Столбец 1', summary: 'count'},
            {name: 'col2', label: 'Столбец 2', summary: 'sum'}
        ],
        dataSet: [
            {col1: "1 Строка", col2: "1"},
            {col1: "2 Строка", col2: "2"},
            {col1: "1 Строка", col2: "3"}
        ],
        showGroupingPanel: false
    }
});
```

Строки таблицы будут объединяться, если значения в ячейках группировочного столбца будут совпадают друг с другом.

Для отображения группировочной панели необходимо установить свойство **showGroupingPanel** в значение **true**. Кроме этого, заголовки столбцов должны быть доступны для перетаскивания, т.е. свойства **showHeader** должно иметь значение **true**.

По умолчанию массив **groups** будет пустым, так как изначально группировка не проводится. При перемещение столбца на группировочную панель, к нему будет добавлена именованная коллекция **Map**. В ней по уникальному ключу будут хранится все группировочные строки в виде отдельного массива. К таким строкам будет добавлен специальный флаг **$group** со значением **true**, а к обычным строкам дерева будет добавлено свойство **$groupParent** с ссылкой на группировочную строку, в которой они оказались в результате группировки. Кроме этого, группировочная строка будет содержать список всех строк, которые будет находится внутри нее.

Если группировочный столбец удалить с панели, то ссылка на него будет автоматически удалена из массива **groups**.
