Свойство **items** хранит список всех строк, которые находятся на данный момент в контейнере таблицы.

По своей структуре данное свойство является массивом. В него помещаются все строки таблицы с корневыми и вложенными узлами деревьев любого уровня, которые были развернуты, в независимость от того, помещаются ли они в видимую область контейнера или нет.

Неразвернутые вложенные узлы столбцов с режимом отображения узлов деревьев в этот массив не попадают.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=140_
import '/components/grids/table/table.js';
ODA({
    is: 'my-component',
    template: `
        <div>Количество развернутых узлов в контейнере: {{$refs.table.items.length}}</div>
        <oda-table ref="table" :data-set :columns show-header col-lines auto-width></oda-table>
    `,
    props: {
        columns: [
            {name: 'col1', label: 'Столбец 1'},
            {name: 'col2', label: 'Столбец 2', treeMode: true}
        ],
        dataSet: [
            {col1: "1 строка", col2:"1 узел"},
            {col1: "2 строка", col2:"2 узел",
                items:[
                    {col2: "2.1 узел"},
                    {col2: "2.2 узел",
                    items:[
                        {col2:"2.2.1 узел"},
                        {col2:"2.2.2 узел"},
                        {col2:"2.2.3 узел"},
                    ]},
                    {col2:"2.3 узел"}
                ]},
        ],
    }
});
```

При свертывании или развертывании узлов свойство **items** пересчитывается автоматически. Поэтому количество элементов в этом массиве будет меняться динамически в зависимости от действий пользователя.
