Свойство **showFilter** позволяет отобразить строку фильтрации, с помощью которой можно задать условие для отбора строк таблицы по одному или нескольким указанным значениям.

Если это свойство уставлено в значение **true**, то в заголовке столбца отображается дополнительная строка с элементом ввода, в котором можно указать условие для отбора требуемых строк таблицы. В результате этого в компоненте будут отображаться только те строки, значения которых полностью или частично удовлетворяют заданному фильтру.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=180_
import '/components/grids/table/table.js';
ODA({
    is: 'my-component',
    template: `
        <label>Показать строку фильтрации <input type="checkbox" ::value="showFilter"></label>
        <oda-table ref="table" :show-filter :data-set :columns show-header row-lines col-lines auto-width></oda-table>
    `,
    props: {
        columns: [
            {name: 'col1', label: 'Столбец 1'},
            {name: 'col2', label: 'Столбец 2'}
        ],
        dataSet: [
            {col1: "1 Строка", col2: "1"},
            {col1: "2 Строка", col2: "2"},
            {col1: "3 Строка", col2: "3"}
        ],
        showFilter: false
    }
});
```

Для задания фильтра первоначально необходимо отобразить сам заголовок столбца, установив свойство **showHeader** в значение **true**.

В качестве условия фильтрации используется только значения строк таблицы. Однако значения отдельных строк можно объединять в фильтре с помощью логических операций **И** и **ИЛИ**. Для них используются следующих обозначения:

1. &, &&, and — логическая операция И.
1. |, ||, or  — логическая операция ИЛИ.

По умолчанию свойство **showFilter** установлено в значение **false**. Поэтому строка фильтра при отображении заголовка столбца изначально не отображается.

Если массив **columns** не задан, то строка фильтра не отображается.
