Свойство **showTreeLines** позволяет отображать направляющие линии в структуре развернутых узлов деревьев.

Данное свойство работает только со столбцами таблицы, у которых включен режим отображение данных в виде дерева с помощью свойства **treeMode**.

Если это свойство уставлено в значение **true**, то узлы дерева, расположенные на одном уровне, соединяются вертикальными линиями для большой наглядности и более удобной работы с ними.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=220_
import '/components/grids/table/table.js';
ODA({
    is: 'my-component',
    template: `
        <label>Показать линии <input type="checkbox" ::value="showTreeLines" ></label> <br>
        <oda-table :show-tree-lines :data-set :columns show-header row-lines col-lines auto-width></oda-table>
    `,
    props: {
        columns: [
            {name: 'col1', label: 'Столбец 1'},
            {name: 'col2', label: 'Столбец 2', treeMode: true}
        ],
        dataSet: [
            {col1: "1 строка", col2:"1 узел"},
            {col1: "2 строка", col2:"2 узел",
                items:[
                    {col2: "2.1 узел"},
                    {col2: "2.2 узел",
                    items:[
                        {col2:"2.2.1 узел"},
                        {col2:"2.2.2 узел"},
                        {col2:"2.2.3 узел"},
                    ]},
                    {col2:"2.3 узел"}
                ]},
        ],
        showTreeLines: false
    }
});
```

По умолчанию свойство **showTreeLines** установлено в значение **false**. Из-за этого дополнительные линии у узлов дерева изначально не отображаются.

``` error_md Эти линии появляются только при развертывании узлов. Если узлы уже развернуты, то при установки свойства **showTreeLines** в значение **true**, для появления направляющих линий структуры их придется заново переоткрыть.
```
