Свойство **size** позволяет определить количество строк, которые на данный момент находятся в контейнере таблицы.

Это свойство имеет режим доступа только для чтения. Фактически оно определяется количеством строк, которые находятся как в видимой области контейнера, так и за её пределами, т.е. неразвернутые узлы деревьев в это количество входить не будут, так как они в контейнере не располагаются.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=200_
import '/components/grids/table/table.js';
ODA({
    is: 'my-component',
    template: `
        <div>Количество строк в контейнере: {{$refs.table.size}}</div>
        <oda-table ref="table" :data-set :columns show-header col-lines row-lines auto-width></oda-table>
    `,
    props: {
        columns: [
            {name: 'col1', label: 'Столбец 1'},
            {name: 'col2', label: 'Столбец 2', treeMode: true}
        ],
        dataSet: [
            {col1: "1 строка", col2:"1 узел"},
            {col1: "2 строка", col2:"2 узел",
                items:[
                    {col2: "2.1 узел"},
                    {col2: "2.2 узел",
                    items:[
                        {col2:"2.2.1 узел"},
                        {col2:"2.2.2 узел"},
                        {col2:"2.2.3 узел"},
                    ]},
                    {col2:"2.3 узел"}
                ]
            },
        ],
    }
});
```

Очевидно, что значение этого свойства зависит от количества развернутых узлов из общего количества узлов, указанных в наборе данных **dataSet**.
