Свойство **sorts** содержит массив столбцов, которые находятся на данный момент в режиме сортировки.

По умолчанию все строки таблицы располагаются в том порядке, в котором они были заданы в наборе данных **dataSet**. Однако этот порядок можно изменить, разрешив сортировку их значений по возрастанию или убыванию с помощью свойства **allowSort**. Если это свойство установить в значение **true**, то в строке заголовка у каждого столбца появится дополнительная кнопка, которая позволит выполнить сортировку строк таблицы в нужном порядке.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=200_
import '/components/grids/table/table.js';
ODA({
    is: 'my-component',
    template: `
        <label>Разрешить сортировку <input type="checkbox" ::value="allowSort" ></label>
        <div>Порядок сортировки {{$refs.table.sorts[0] ? $refs.table.sorts[0].$sort : 'Нет'}}</div>
        <oda-table ref="table" :allow-sort :data-set :columns  show-header row-lines col-lines auto-width></oda-table>
    `,
    props: {
        columns: [
            {name: 'col1', label: 'Столбец 1'},
            {name: 'col2', label: 'Столбец 2'}
        ],
        dataSet: [
            {col1: "1 Строка", col2: "1"},
            {col1: "2 Строка", col2: "2"},
            {col1: "1 Строка", col2: "2"}
        ],
        allowSort: false
    }
});
```

При нажатии на эту кнопку с изображением стрелки вверх или вниз будет последовательно изменяться порядок сортировки строк таблицы. При этом ссылка на столбец, у которого задан порядок сортировки, помещается в массив **sorts**. Кроме этого, в данный столбец добавляется свойство с именем **$sort**, определяющее порядок сортировки узлов. Это свойство может принимать одно из трех возможных значений:

1. $sort = 1 — массив отсортирован по возрастанию.
1. $sort = -1 — массив отсортирован по убыванию.
1. $sort = 0 — массив не отсортирован.

При каждом третьем нажатии этой кнопки сортировка будет отменена и строки таблицы будут отображаться в том порядке, в котором они были заданы в исходном наборе данных **dataSet**. При этом ссылка на столбец из массива **sorts** автоматически будет удалена, но в самом столбце все равно останется свойство **$sort** со значением 0, свидетельствующем о том, что сортировка по этому столбцу на данный момент уже не осуществляется.

Для сортировки строк обязательно необходимо отобразить заголовок таблицы, задав значение **true** у свойства **showHeader**. Иначе кнопки сортировки доступны не будут.

По умолчанию столбцы не сортируются, поэтому массив **sorts** изначально будет пустым.
