Свойство **allowSort** позволяет сортировать узлы дерева по возрастанию или по убыванию.

Если это свойство уставлено в значение **true**, то в заголовке столбца появляется дополнительный элемент в виде изображения стрелки, при нажатии на которую узлы дерева сортируются по возрастанию или по убыванию.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=220_
import '/components/grids/tree/tree.js';
ODA({
    is: 'my-component',
    template: `
        <label>Разрешить сортировку <input type="checkbox" ::value="allowSort" ></label>
        <oda-tree ref="tree" :allow-sort :data-set :columns show-header></oda-tree>
    `,
    props: {
        columns: [
            {name: 'name', label: 'Мой столбец', treeMode: true}
        ],
        dataSet: [
            {name: "1 строка"},
            {name:"2 строка",
                items:[
                    {name:"2.1 строка"},
                    {name:"2.2 строка",
                    items:[
                        {name:"2.2.1 строка"},
                        {name:"2.2.2 строка"},
                        {name:"2.2.3 строка"},
                    ]},
                    {name:"2.3 строка"}
                ]
            },
            {name:"3 строка"},
        ],
        allowSort: false
    }
});
```

Для сортировки узлов обязательно необходимо отобразить заголовок столбца, задав значение **true** у свойства **showHeader**.

При нажатии на иконку с изображением стрелки сортировка узлов будет меняться последовательно с возрастания на убывание, а третье нажатие вернет исходный порядок узлов, указанный в наборе данных **dataSet**.

По умолчанию свойство **allowSort** установлено в значение **false**. Поэтому сортировать узлы изначально будет запрещено, даже если заголовок у дерева отображается.
