Свойство **colLines** определяет наличие или отсутствие вертикальных линий в конце каждой строки.

Если это свойство установлено в значение **true**, то в конце каждой строки появится дополнительная линия, заканчивающая столбец, в котором отображаются узлы дерева.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=140_
import '/components/grids/tree/tree.js';
ODA({
    is: 'my-component',
    template: `
        <label>Линии столбца<input type="checkbox" ::value="colLines" ></label> <br>
        <label>Привязка по ширине <input type="checkbox" ::value="autoWidth"></label> <br>
        <oda-tree :data-set :col-lines :auto-width></oda-tree>
    `,
    props: {
        dataSet: [
            {name: "1 строка"},
            {name:"2 строка",
                items:[
                    {name:"2.1 строка"},
                    {name:"2.2 строка",
                    items:[
                        {name:"2.2.1 строка"},
                        {name:"2.2.2 строка"},
                        {name:"2.2.3 строка"},
                    ]},
                    {name:"2.3 строка"}
                ]
            },
            {name:"3 строка"},
        ],
        colLines: false,
        autoWidth: true
    }
});
```

Если ширина столбца не привязана к ширине контейнера, то линии столбцов будут отображаться в том месте, в котором заканчивается содержимое каждой строки. В противном случае все линии будут располагаться на одном уровне, где заканчивается сам контейнер.

Свойство **colLines** по умолчанию установлено в значение **false**. Поэтому вертикальные линии в конце каждой строки изначально не появляются.
