Свойство **cols** предназначено для вывода указателя на столбец таблицы, в котором отображаются узлы дерева.

Фактически это свойство возвращает либо массив столбцов **columns**, либо массив из одного объекта, который задает параметры столбца по умолчанию, когда свойство **columns** не задано. В этом случае у объекта столбца будут заданы только два обязательных свойства:

1. **name** — имя столбца, значение которого должно совпадать со значением свойства **keyName**, определяющего свойство набора данных **dataSet**, которое используется для отображения узлов дерева.
2. **treeMode** — режим отображения столбца в виде дерева, которое имеет значение **true**.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=140_
import '/components/grids/tree/tree.js';
ODA({
    is: 'my-component',
    template: `
        <span>Имя столбца name: {{$refs.tree.cols[0].name}}</span> <br>
        <span>Режим отображения treeMode: {{$refs.tree.cols[0].treeMode}}</span>
        <oda-tree ref="tree" :data-set></oda-tree>
    `,
    props: {
        dataSet: [
            {name: "1 строка"},
            {name:"2 строка",
                items:[
                    {name:"2.1 строка"},
                    {name:"2.2 строка",
                    items:[
                        {name:"2.2.1 строка"},
                        {name:"2.2.2 строка"},
                        {name:"2.2.3 строка"},
                    ]},
                    {name:"2.3 строка"}
                ]
            },
            {name:"3 строка"},
        ]
    }
});
```

Если столбцы заданы с помощью массива **columns**, то **cols** возвращает этот массив, а не столбец по умолчанию.
