Свойство **filters** содержит массив столбцов, у которых заданы условия выбора узлов дерева.

Если пользователь в строке ввода укажет любой фильтр, то его значение будет сохранено в свойстве **$filter** текущего столбца. Одновременно с этим объект этого столбца будет добавлен в массив **filters** для более быстрого и удобного доступа ко всем заданным фильтрам.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=220_
import '/components/grids/tree/tree.js';
ODA({
    is: 'my-component',
    template: `
        <label>Показать фильтр <input type="checkbox" ::value="showFilter" checked></label>
        <div>Заданный фильтр: {{$refs.tree.filters[0].$filter}} </div>
        <oda-tree ref="tree" :show-filter :data-set :columns show-header></oda-tree>
    `,
    props: {
        columns: [
            {name: 'name', label: 'Мой столбец', treeMode: true}
        ],
        dataSet: [
            {name: "1 строка"},
            {name:"2 строка",
                items:[
                    {name:"2.1 строка"},
                    {name:"2.2 строка",
                    items:[
                        {name:"2.2.1 строка"},
                        {name:"2.2.2 строка"},
                        {name:"2.2.3 строка"},
                    ]},
                    {name:"2.3 строка"}
                ]
            },
            {name:"3 строка"},
        ],
        showFilter: true
    }
});
```

Для возможности ввода фильтра необходимо первоначально отобразить строку заголовка столбца с помощью свойства **showHeader** и включить режим задания отображения строки фильтрации, указав в свойстве **showFilter** значение **true**.

В дереве всегда используется только один столбец таблицы для отображения всех узлов. Поэтому при задании фильтра в массиве **filters** будет всегда находится только один столбец.

По умолчанию массив **filters** будет пустым, так как изначально условие фильтрации узлов дерева не задано.

Если очистить фильтр у столбца, то свойство **$filter** из объект столбца будет автоматически удалено, а ссылка на сам столбец будет удалена из массива **filters**.
