Свойство **focusedNode** предназначено для хранения указателя на текущий узел дерева, который находится на данный момент в фокусе.

Для того чтобы узел дерева мог получить указатель фокуса, необходимо установить свойство **allowFocus** в значение **true**.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=140_
import '/components/grids/tree/tree.js';
ODA({
    is: 'my-component',
    template: `
        <label>Разрешение фокуса<input type="checkbox" ::value="allowFocus" checked></label> <br>
        <label>Узел в фокусе: <input ::value="focusedNode.name"></label>
        <oda-tree :data-set ::focused-node :allow-focus></oda-tree>
    `,
    props: {
        dataSet: [
            {name: "1 строка"},
            {name:"2 строка",
                items:[
                    {name:"2.1 строка"},
                    {name:"2.2 строка",
                    items:[
                        {name:"2.2.1 строка"},
                        {name:"2.2.2 строка"},
                        {name:"2.2.3 строка"},
                    ]},
                    {name:"2.3 строка"}
                ]
            },
            {name:"3 строка"},
        ],
        allowFocus: true,
        focusedNode: {name: 'Щелкните по элементу'}
    }
});
```

При щелчке левой или правой кнопкой мыши по соответствующему узлу дерева в свойство **focusedNode** будет записана ссылка на объект этого узла.

Используя эту ссылку, можно узнать не только какой узел находится сейчас в фокусе, но и изменить его значение.

Это свойство можно использовать как для чтения, так и для записи. Например, если записать в него значение элемента из массива **items**, то соответствующий узел в структуре дерева получит фокус автоматически, как показано в примере [**«Изменение фокуса»**]().

При любом изменении свойства **focusedNode** происходит событие **focused-node-changed**. Его можно обработать так, как показано в примере [**«Событие focused-node-changed»**]().

Это свойство аналогично свойству **focusedRow** — любое изменение свойства **focusedRow** приводит к изменению свойства **focusedNode**, и наоборот.
