Свойство **footer** позволяет узнать содержимое нижнего колонтитула дерева.

По своей структуре это свойство является объектом, у которого задано свойство совпадающее с именем столбца, в котором отображаются узлы дерева. В этом свойстве и хранится содержимое, которое выводится в колонтитуле.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=220_
import '/components/grids/tree/tree.js';
ODA({
    is: 'my-component',
    template: `
        <div>Показать подвал <input type="checkbox" ::value="showFooter"></div>
        <div>Значение свойства: {{JSON.stringify($refs.tree.footer)}}</div>
        <oda-tree ref="tree" :data-set :show-footer></oda-tree>
    `,
    props: {
        dataSet: [
            {name: "1 строка"},
            {name:"2 строка",
                items:[
                    {name:"2.1 строка"},
                    {name:"2.2 строка",
                    items:[
                        {name:"2.2.1 строка"},
                        {name:"2.2.2 строка"},
                        {name:"2.2.3 строка"},
                    ]},
                    {name:"2.3 строка"}
                ]
            },
            {name:"3 строка"},
        ],
        showFooter: false
    }
});
```

По умолчанию в нижнем колонтитуле выводится информация об общем количестве узлов, расположенных в видимой области контейнера, с уточнением номера первого и последнего узла в квадратных скобках.
