Свойство **items** хранит список всех узлов, которые находятся на данный момент в контейнере дерева.

По своей структуре данное свойство является массивом. В него помещаются все корневые и их вложенные узлы любого уровня, которые были развернуты, вне зависимости от того, помещаются ли они в видимую область контейнера или нет.

Неразвернутые вложенные узлы в этот массив из исходного набора данных **dataSet** не попадают.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=140_
import '/components/grids/tree/tree.js';
ODA({
    is: 'my-component',
    template: `
        <div>Количество развернутых узлов в контейнере: {{$refs.tree.items.length}}</div>
        <oda-tree ref="tree" :data-set></oda-tree>
    `,
    props: {
        dataSet: [
            {name: "1 строка"},
            {name:"2 строка",
                items:[
                    {name:"2.1 строка"},
                    {name:"2.2 строка",
                    items:[
                        {name:"2.2.1 строка"},
                        {name:"2.2.2 строка"},
                        {name:"2.2.3 строка"},
                    ]},
                    {name:"2.3 строка"}
                ]
            },
            {name:"3 строка"},
        ]
    }
});
```

При свертывании или развертывании узлов свойство **items** пересчитывается автоматически. Поэтому количество элементов в этом массиве может меняться динамически.
