Свойство **showFilter** позволяет отобразить строку фильтрации, с помощью которой можно задать фильтр для отбора узлов дерева по какому-либо условию.

Если это свойство уставлено в значение **true**, то в заголовке столбца отображается дополнительная строка с элементом ввода, в котором можно указать условие для отбора требуемых узлов дерева. В результате этого в компоненте будут отображаться только те узлы, которые удовлетворяют заданному условию.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=220_
import '/components/grids/tree/tree.js';
ODA({
    is: 'my-component',
    template: `
        <label>Показать заголовок <input type="checkbox" ::value="showFilter" ></label>
        <oda-tree ref="tree" :show-filter :data-set :columns show-header></oda-tree>
    `,
    props: {
        columns: [
            {name: 'name', label: 'Мой столбец', treeMode: true}
        ],
        dataSet: [
            {name: "1 строка"},
            {name:"2 строка",
                items:[
                    {name:"2.1 строка"},
                    {name:"2.2 строка",
                    items:[
                        {name:"2.2.1 строка"},
                        {name:"2.2.2 строка"},
                        {name:"2.2.3 строка"},
                    ]},
                    {name:"2.3 строка"}
                ]
            },
            {name:"3 строка"},
        ],
        showFilter: false
    }
});
```

Для задания фильтра первоначально необходимо отобразить сам заголовок столбца, установив свойство **showHeader** в значение **true**.

В качестве условия фильтрации используется только надписи узлов дерева. Однако значения отдельных надписей можно объединять в фильтре с помощью логических операций И и ИЛИ. Для них можно использовать следующие обозначения:

1. &, &&, and — логическая операция И.
1. |, ||, or  — логическая операция ИЛИ.

По умолчанию свойство **showFilter** установлено в значение **false**. Поэтому строка фильтра при отображении заголовка столбца изначально не отображается.

Если массив **columns** не задан, то строка фильтра не отображается.
