Свойство **showGroupingFooter** позволяет отобразить нижний колонтитул в конце каждой группы узлов дерева.

Если это свойство уставлено в значение **true**, то в конце каждой группы появится нижний колонтитул. На нем будет выводиться информация об общем количестве узлов, которые были объединены в результате группировки.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=220_
import '/components/grids/tree/tree.js';
ODA({
    is: 'my-component',
    template: `
        <label>Показать панель группировки <input type="checkbox" ::value="showGroupingPanel" ></label>
        <oda-tree ref="tree" :data-set :columns show-header :show-grouping-panel></oda-tree>
    `,
    props: {
        columns: [
            {name: 'name', label: 'Мой столбец', treeMode: true}
        ],
        dataSet: [
            {name: "1 строка"},
            {name:"2 строка",
                items:[
                    {name:"2.1 строка"},
                    {name:"2.2 строка",
                    items:[
                        {name:"2.2.1 строка"},
                        {name:"2.2.2 строка"},
                        {name:"2.2.3 строка"},
                    ]},
                    {name:"2.3 строка"}
                ]
            },
            {name:"1 строка"},
        ],
        showGroupingPanel: false
    }
});
```

Для осуществления группировки необходимо отобразить группировочную панель, установив свойство **show-grouping-panel** в значение **true**, и перетащить на нее столбец, расположенный в строке заголовка дерева, первоначально отобразив его с помощью свойства **showHeader**.

По умолчанию свойство **showGroupingFooter** установлено в значение **false**. Поэтому нижний колонтитул в конце каждой группы изначально отображаться не будет.

Однако если столбец уже сгруппирован, то саму панель можно убрать, установив свойство **showGroupingPanel** в значение **false**. При этом группировка не будет отменена. Отказаться от нее можно только удалив столбец с панели, нажав на кнопку с крестиком в его названии.

Если массив **columns** не задан, то перетащить столбец на панель группировки будет нельзя.
