Свойство **showGroupingPanel** позволяет отобразить дополнительную панель, с помощью которой можно выполнить группировку узлов дерева.

На эту панель можно перетащить столбец, схватившись за его заголовок левой кнопкой мыши. В результате этого все узлы дерева будут дополнительно сгруппированы по значениям корневых узлов, которые размещены в этом столбце.

Для отображения группировочной панели свойство **show-grouping-panel** необходимо установить в значение **true**. Кроме это, заголовки столбцов должны быть доступны для перетаскивания, т.е. свойства **showHeader** необходимо первоначально установить в значение **true**.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=220_
import '/components/grids/tree/tree.js';
ODA({
    is: 'my-component',
    template: `
        <label>Показать панель группировки <input type="checkbox" ::value="showGroupingPanel" ></label>
        <oda-tree ref="tree" :data-set :columns show-header :show-grouping-panel></oda-tree>
    `,
    props: {
        columns: [
            {name: 'name', label: 'Мой столбец', treeMode: true}
        ],
        dataSet: [
            {name: "1 строка"},
            {name:"2 строка",
                items:[
                    {name:"2.1 строка"},
                    {name:"2.2 строка",
                    items:[
                        {name:"2.2.1 строка"},
                        {name:"2.2.2 строка"},
                        {name:"2.2.3 строка"},
                    ]},
                    {name:"2.3 строка"}
                ]
            },
            {name:"1 строка"},
        ],
        showGroupingPanel: false
    }
});
```

В дереве всегда используется только один столбец таблицы для отображения всех узлов. Поэтому группировка по этому столбцу просто приведет к объединению корневых узлов при условии, что значения их надписей совпадают друг с другом.

По умолчанию свойство **showGroupingPanel** установлено в значение **false**. Поэтому группировочная панель у дерева изначально не отображается.

Однако если столбец уже сгруппирован, то саму панели можно убрать, установив свойство **showGroupingPanel** в значение **false**. При этом группировка не будет отменена. Отказаться от нее можно только удалив столбец с панели, нажав на кнопку с крестиком в его названии.

Если массив **columns** не задан, то перетащить столбец на панель группировки будет нельзя.
