Свойство **showTreeLines** позволяет отображать направляющие линии в структуре развернутых узлов дерева.

Если это свойство уставлено в значение **true**, то узлы дерева, расположенные на одном уровне, соединяются вертикальными линиями для большой наглядности и более удобной работы с ними.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=140_
import '/components/grids/tree/tree.js';
ODA({
    is: 'my-component',
    template: `
        <label>Показать линии <input type="checkbox" ::value="showTreeLines" ></label> <br>
        <oda-tree :data-set :show-tree-lines></oda-tree>
    `,
    props: {
        dataSet: [
            {name: "1 строка"},
            {name:"2 строка",
                items:[
                    {name:"2.1 строка"},
                    {name:"2.2 строка",
                    items:[
                        {name:"2.2.1 строка"},
                        {name:"2.2.2 строка"},
                        {name:"2.2.3 строка"},
                    ]},
                    {name:"2.3 строка"}
                ]
            },
            {name:"3 строка"},
        ],
        showTreeLines: false
    }
});
```

По умолчанию свойство **showTreeLines** установлено в значение **false**. Из-за этого дополнительные линии у узлов дерева изначально не отображаются.

``` error_md Эти линии появляются только при развертывании узлов. Если узлы уже развернуты, то при установки свойства **showTreeLines** в значение **true**, для появления направляющих линий структуры их придется заново переоткрыть.
```
