Свойство **size** позволяет определить количество узлов, которые на данный момент находятся в контейнере.

Это свойство имеет режим доступа только для чтения. Фактически оно определяется количеством строк, которые находятся как в видимой области контейнера, так и за её пределами, т.е. неразвернутые узлы дерева в это количество не входят, так как они в контейнере не располагаются.

Например:

```javascript _run_line_edit_loadoda_[my-component.js]_h=140_
import '/components/grids/tree/tree.js';
ODA({
    is: 'my-component',
    template: `
        <div>Количество узлов в контейнере: {{$refs.tree.size}}</div>
        <oda-tree ref="tree" :data-set></oda-tree>
    `,
    props: {
        dataSet: [
            {name: "1 строка"},
            {name:"2 строка",
                items:[
                    {name:"2.1 строка"},
                    {name:"2.2 строка",
                    items:[
                        {name:"2.2.1 строка"},
                        {name:"2.2.2 строка"},
                        {name:"2.2.3 строка"},
                    ]},
                    {name:"2.3 строка"}
                ]
            },
            {name:"3 строка"},
        ]
    }
});
```

Очевидно, что значение этого свойства зависит от количества развернутых узлов из общего числа узлов,  находящихся в списке **dataSet**.
